Drawing Workbench: Difference between revisions

From FreeCAD Documentation
mNo edit summary
(Marked this version for translation)
 
(61 intermediate revisions by 13 users not shown)
Line 1: Line 1:
<languages/>
The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window and to insert that window in a drawing, for example a sheet with a border, a title and your logo and finally print that sheet. The Drawing module is currently under construction and more or less a technology preview!
<translate>


<!--T:69-->
== GUI Tools ==
{{Docnav
|
|
|IconL=
|IconR=
}}


<!--T:73-->
{{Drawing Tools}}
{{VeryImportantMessage|The '''Drawing Workbench''' is no longer included after version 0.20.<br>
The [[TechDraw_Workbench|TechDraw Workbench]] is its more advanced replacement.}}


<!--T:72-->
[[Image:Workbench_Drawing.svg|thumb|128px|Drawing workbench icon]]


== Introduction == <!--T:64-->
'''Note'''
The [[Draft Module]] has its own [[Draft_Drawing]] too to place Draft objects on paper. It has a couple of extra capabilities over the standard Drawing tools, and supports specific objects like [[Draft Dimension|Draft dimensions]].


<!--T:1-->
The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window and to insert that window in a drawing, for example a sheet with a border, a title and your logo and finally print that sheet.


</translate>
[[Image:Drawing_extraction.png|800px]]
{{TOCright}}
[[Image:Drawing_extraction.png|600px]]
<translate>


== Tools == <!--T:2-->
In the picture you see the main concepts of the Drawing module. The document contains a shape object (Schenkel) which we want to extract to a drawing. Therefore a "Page" is created. A page gets instantiated through a template, in this case the "A3_Landscape" template. The template is an SVG document which can hold your usual page frame, your logo or comply to your presentation standards.


<!--T:3-->
In this page we can insert one or more views. Each view has a position on the page (Properties X,Y), a scale factor (Property scale) and additional properties. Every time the page or the view or the referenced object changes the page gets regenerated and the page display updated.
These are tools for creating, configuring and exporting 2D drawing sheets


<!--T:52-->
== Scripting ==
* [[Image:Drawing_New.png|32px]] [[Drawing_Open_SVG|Open scalable vector graphic]]: Opens a drawing sheet previously saved as an SVG file


<!--T:53-->
At the moment the end user(GUI) workflow is very limited, so the scripting API is more interesting. Here follow examples on how to use the scripting API of the drawing module.
* [[Image:Drawing_Landscape_A3.png|32px]] [[Drawing_Landscape_A3|New A3 landscape drawing]]: Creates a new drawing sheet from FreeCAD's default A3 template


<!--T:54-->
Here a script that can easily fill the [[Macro_CartoucheFC]] leaf FreeCAD A3_Landscape.
* [[Image:Drawing_View.png|32px]] [[Drawing_View|Insert a view]]: Inserts a view of the selected object in the active drawing sheet


<!--T:55-->
=== Simple example ===
* [[Image:Drawing_Annotation.png|32px]] [[Drawing_Annotation|Annotation]]: Adds an annotation to the current drawing sheet


<!--T:56-->
First of all you need the Part and the Drawing module:
* [[Image:Drawing_Clip.png|32px]] [[Drawing_Clip|Clip]]: Adds a clip group to the current drawing sheet
import FreeCAD, Part, Drawing
Create a small sample part
Part.show(Part.makeBox(100,100,100).cut(Part.makeCylinder(80,100)).cut(Part.makeBox(90,40,100)).cut(Part.makeBox(20,85,100)))
Direct projection. The G0 means hard edge, the G1 is tangent continuous.
Shape = App.ActiveDocument.Shape.Shape
[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape)
print "visible edges:", len(visibleG0.Edges)
print "hidden edges:", len(hiddenG0.Edges)
Everything was projected on the Z-plane:
print "Bnd Box shape: X=",Shape.BoundBox.XLength," Y=",Shape.BoundBox.YLength," Z=",Shape.BoundBox.ZLength
print "Bnd Box project: X=",visibleG0.BoundBox.XLength," Y=",visibleG0.BoundBox.YLength," Z=",visibleG0.BoundBox.ZLength
Different projection vector
[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape,App.Vector(1,1,1))
Project to SVG
resultSVG = Drawing.projectToSVG(Shape,App.Vector(1,1,1))
print resultSVG


<!--T:57-->
=== The parametric way ===
* [[Image:Drawing_Openbrowser.png|32px]] [[Drawing_Openbrowser|Open Browser]]: Opens a preview of the current sheet in the browser


<!--T:58-->
Create the body
* [[Image:Drawing_Orthoviews.png|32px]] [[Drawing_Orthoviews|Ortho Views]]: Automatically creates orthographic views of an object on the current drawing sheet
import FreeCAD
import Part
import Drawing


<!--T:59-->
# Create three boxes and a cylinder
* [[Image:Drawing_Symbol.png|32px]] [[Drawing_Symbol|Symbol]]: Adds the contents of a SVG file as a symbol on the current drawing sheet
App.ActiveDocument.addObject("Part::Box","Box")
App.ActiveDocument.Box.Length=100.00
App.ActiveDocument.Box.Width=100.00
App.ActiveDocument.Box.Height=100.00


<!--T:60-->
App.ActiveDocument.addObject("Part::Box","Box1")
* [[Image:Drawing_DraftView.png|32px]] [[Draft_Drawing|Draft View]]: Inserts a special Draft view of the selected object in the current drawing sheet
App.ActiveDocument.Box1.Length=90.00
App.ActiveDocument.Box1.Width=40.00
App.ActiveDocument.Box1.Height=100.00


<!--T:61-->
App.ActiveDocument.addObject("Part::Box","Box2")
* [[Image:Drawing_SpreadsheetView.png|32px]] [[Drawing_SpreadsheetView|Spreadsheet View]]: Inserts a view of a selected spreadsheet in the current drawing sheet
App.ActiveDocument.Box2.Length=20.00
App.ActiveDocument.Box2.Width=85.00
App.ActiveDocument.Box2.Height=100.00


<!--T:62-->
App.ActiveDocument.addObject("Part::Cylinder","Cylinder")
* [[Image:Drawing_Save.png|32px]] [[Drawing_Save|Save sheet]]: Saves the current sheet as a SVG file
App.ActiveDocument.Cylinder.Radius=80.00
App.ActiveDocument.Cylinder.Height=100.00
App.ActiveDocument.Cylinder.Angle=360.00
# Fuse two boxes and the cylinder
App.ActiveDocument.addObject("Part::Fuse","Fusion")
App.ActiveDocument.Fusion.Base = App.ActiveDocument.Cylinder
App.ActiveDocument.Fusion.Tool = App.ActiveDocument.Box1


<!--T:63-->
App.ActiveDocument.addObject("Part::Fuse","Fusion1")
* [[Drawing_ProjectShape|Project Shape]]: Creates a projection of the selected object (Source) in the 3D view.
App.ActiveDocument.Fusion1.Base = App.ActiveDocument.Box2
App.ActiveDocument.Fusion1.Tool = App.ActiveDocument.Fusion
# Cut the fused shapes from the first box
App.ActiveDocument.addObject("Part::Cut","Shape")
App.ActiveDocument.Shape.Base = App.ActiveDocument.Box
App.ActiveDocument.Shape.Tool = App.ActiveDocument.Fusion1
# Hide all the intermediate shapes
Gui.ActiveDocument.Box.Visibility=False
Gui.ActiveDocument.Box1.Visibility=False
Gui.ActiveDocument.Box2.Visibility=False
Gui.ActiveDocument.Cylinder.Visibility=False
Gui.ActiveDocument.Fusion.Visibility=False
Gui.ActiveDocument.Fusion1.Visibility=False
Insert a Page object and assign a template
App.ActiveDocument.addObject('Drawing::FeaturePage','Page')
App.ActiveDocument.Page.Template = App.getResourceDir()+'Mod/Drawing/Templates/A3_Landscape.svg'


<!--T:4-->
Create a view on the "Shape" object, define the position and scale and assign it to a Page
* {{Emphasis|Note:}} the [[Draft Drawing|Draft Drawing]] tool is used with [[Draft Workbench|Draft objects]]. It has some additional capabilities over the Drawing tools, and supports specific objects like [[Draft Dimension|Draft dimensions]].
App.ActiveDocument.addObject('Drawing::FeatureViewPart','View')
App.ActiveDocument.View.Source = App.ActiveDocument.Shape
App.ActiveDocument.View.Direction = (0.0,0.0,1.0)
App.ActiveDocument.View.X = 10.0
App.ActiveDocument.View.Y = 10.0
App.ActiveDocument.Page.addObject(App.ActiveDocument.View)


<!--T:6-->
Create a second view on the same object but this time the view will be rotated by 90 degrees.
== Workflow ==
App.ActiveDocument.addObject('Drawing::FeatureViewPart','ViewRot')
The document contains a 3D shape object (leg) from which we want to produce a drawing. Therefore a "Page" is created. A page it's instantiated from a template, for example, the "A3_Landscape" template. The template is an [[SVG|SVG]] document which can hold a page frame, a logo, and other elements.
App.ActiveDocument.ViewRot.Source = App.ActiveDocument.Shape
App.ActiveDocument.ViewRot.Direction = (0.0,0.0,1.0)
App.ActiveDocument.ViewRot.X = 290.0
App.ActiveDocument.ViewRot.Y = 30.0
App.ActiveDocument.ViewRot.Scale = 1.0
App.ActiveDocument.ViewRot.Rotation = 90.0
App.ActiveDocument.Page.addObject(App.ActiveDocument.ViewRot)


<!--T:7-->
Create a third view on the same object but with an isometric view direction. The hidden lines are activated too.
In this page we can insert one or more views. Each view has a position on the page, a scale factor, and additional properties. Every time the page or the view or the referenced object changes, the page is regenerated and the page display updated.
App.ActiveDocument.addObject('Drawing::FeatureViewPart','ViewIso')
App.ActiveDocument.ViewIso.Source = App.ActiveDocument.Shape
App.ActiveDocument.ViewIso.Direction = (1.0,1.0,1.0)
App.ActiveDocument.ViewIso.X = 335.0
App.ActiveDocument.ViewIso.Y = 140.0
App.ActiveDocument.ViewIso.ShowHiddenLines = True
App.ActiveDocument.Page.addObject(App.ActiveDocument.ViewIso)


== Scripting == <!--T:8-->
Change something and update. The update process changes the view and the page.
App.ActiveDocument.View.X = 30.0
App.ActiveDocument.View.Y = 30.0
App.ActiveDocument.View.Scale = 1.5
App.ActiveDocument.recompute()


<!--T:9-->
=== Accessing the bits and pieces ===
At the moment the graphical user interface workflow is very limited, so the scripting API is more interesting.


<!--T:65-->
Get the SVG fragment of a single view
See the [[Drawing API example]] page for a description of the functions used to create drawing pages and views.
ViewSVG = App.ActiveDocument.View.ViewResult
print ViewSVG
Get the whole result page (it's a file in the document's temporary directory, only read permission)
print "Resulting SVG document: ",App.ActiveDocument.Page.PageResult
file = open(App.ActiveDocument.Page.PageResult,"r")
print "Result page is ",len(file.readlines())," lines long"


== Templates == <!--T:43-->
Important: free the file!
del file
Insert a view with your own content:
App.ActiveDocument.addObject('Drawing::FeatureView','ViewSelf')
App.ActiveDocument.ViewSelf.ViewResult = """<g id="ViewSelf"
stroke="rgb(0, 0, 0)"
stroke-width="0.35"
stroke-linecap="butt"
stroke-linejoin="miter"
transform="translate(30,30)"
fill="#00cc00"
>


<!--T:44-->
<ellipse cx="40" cy="40" rx="30" ry="15"/>
FreeCAD comes bundled with a set of default templates, but you can find more on the [[Drawing templates]] page.
</g>"""
App.ActiveDocument.Page.addObject(App.ActiveDocument.ViewSelf)
App.ActiveDocument.recompute()


== Extending the Drawing Module == <!--T:45-->
del ViewSVG
That leads to the following result:


<!--T:46-->
[[Image:DrawingScriptResult.jpg|800px]]
Some notes on the programming side of the drawing module will be added to the [[Drawing Documentation]] page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.


<!--T:49-->
=== General Dimensioning and Tolerancing ===
== Tutorials ==
* [[Drawing_tutorial|Drawing tutorial]]
* [[Drawing_Template_HowTo|Drawing Template HowTo]]


== Macros == <!--T:74-->
Drawing dimensions an toleranecs are still under development but you can get some basic functionality with a bit of work.


<!--T:75-->
First you need to get the gdtsvg python module from here (WARNING: This could be broken at any time!):
* {{MacroLink|Icon=Macro_Automatic_drawing.png|Macro_Automatic_drawing|Macro Automatic drawing}}: Allows the user to get the view of his object in a drawing with 4 different position (front,top,iso,right). Needs some modification to be perfectly effective.


<!--T:76-->
https://github.com/jcc242/FreeCAD
* {{MacroLink|Icon=Macro_CartoucheFC.png|Macro_CartoucheFC|Macro CartoucheFC}}: This GUI macro to fill simply all fields of the cartridge of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.


<!--T:77-->
To get a feature control frame, try out the following:
* {{MacroLink|Icon=Macro_CartoucheFC_2.png|Macro_CartoucheFC_2|Macro CartoucheFC 2}}: This GUI macro to fill simply all fields of the cartridge '''model 2''' of the plan implementation worksheet FreeCAD.


<!--T:78-->
import gdtsvg as g # Import the module, I like to give it an easy handle
* {{MacroLink|Icon=Macro_CartoucheFC_Full.png|Macro_CartoucheFC_Full|Macro CartoucheFC Full}}: This GUI macro to fill simply all fields of the cartridge [[Misc_templates_Full|Misc templates Full]] of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.
ourFrame = g.ControlFrame("0","0", g.Perpendicularity(), ".5", g.Diameter(), g.ModifyingSymbols("M"), "A",
g.ModifyingSymbols("F"), "B", g.ModifyingSymbols("L"), "C", g.ModifyingSymbols("I"))
Here is a good breakdown of the contents of a feature control frame: http://www.cadblog.net/adding-geometric-tolerances.htm


<!--T:79-->
The parameters to pass to control frame are:
* {{MacroLink|Icon=Macro_Corner_shapes_wizard.png|Macro_Corner_shapes_wizard/update|Macro Corner shapes wizard/update}}: Pops up a dialog asking for the dimensions of your corner piece, then creates the object in the document and creates a page view with top, front and lateral views of the piece.
#X-coordinate in SVG-coordinate system (type string)
#Y-coordinate in SVG-coordinate system (type string)
#The desired geometric characteristic symbol (tuple, svg string as first, width of symbol as second, height of symbol as third)
#The tolerance (type string)
#(optional) The diameter symbol (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The condition modifying material (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The first datum (type string)
#(optional) The first datum's modifying condition (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The second datum (type string)
#(optional) The second datum's modifying condition (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The third datum (type string)
#(optional) The third datum's material condition (tuple, svg string as first, width of symbol as second, height of symbol as third)


== External links == <!--T:80-->
The ControlFrame function returns a type containing (svg string, overall width of control frame, overall height of control frame)'''


<!--T:50-->
To get a dimension, try out the following:
* [https://www.youtube.com/watch?v=1Hm5Zyjmjac Intro to mechanical drawing on Youtube - by Normal Universe]

import gdtsvg
ourDimension = linearDimension(point1, point2, textpoint, dimensiontext, linestyle=getStyle("visible"),
arrowstyle=getStyle("filled"), textstyle=getStyle("text")

Inputs for linear dimension are:
#point1, an (x,y) tuple with svg-coordinates, this is one of the points you would like to dimension between
#point2, an (x,y) tuple with svg-coordinates, this is the second point you would like to dimension between
#textpoint, an (x,y) tuple of svg-coordinates, this is where the text of your dimension will be
#dimensiontext, a string containing the text you want the dimension to say
#linestyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling the how the lines look
#arrowstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the arrows look
#textstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the text looks

With those two, you can proceed as above for displaying them on the drawing page. This module is very buggy and can be broken at any given moment, bug reports are welcome on the github page for now, or contact jcc242 on the forums if you post a bug somewhere else.

== Templates ==

FreeCAD comes bundled with a set of default templates, but you can find more on the [[Drawing templates]] page.

== Extending the Drawing Module ==

Some notes on the programming side of the drawing module will be added to the [[Drawing Documentation]] page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.


{{docnav|Part Module|Raytracing Module}}


<!--T:47-->
{{languages |{{cn|Drawing Module/cn}} {{de|Drawing Module/de}} {{es|Drawing Module/es}} {{fr|Drawing Module/fr}} {{it|Drawing Module/it}} {{jp|Drawing Module/jp}} {{pl|Drawing Module/pl}} {{ru|Drawing Module/ru}} {{se|Drawing Module/se}} }}
{{Docnav
|
|
|IconL=
|IconR=
}}


</translate>
[[Category:User Documentation]]
{{Drawing Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
[[Category:Obsolete Workbenches{{#translation:}}]]

Latest revision as of 08:46, 8 July 2023

The Drawing Workbench is no longer included after version 0.20.
The TechDraw Workbench is its more advanced replacement.
Drawing workbench icon

Introduction

The Drawing module allows you to put your 3D work on paper. That is, to put views of your models in a 2D window and to insert that window in a drawing, for example a sheet with a border, a title and your logo and finally print that sheet.

Tools

These are tools for creating, configuring and exporting 2D drawing sheets

  • Insert a view: Inserts a view of the selected object in the active drawing sheet
  • Annotation: Adds an annotation to the current drawing sheet
  • Clip: Adds a clip group to the current drawing sheet
  • Open Browser: Opens a preview of the current sheet in the browser
  • Ortho Views: Automatically creates orthographic views of an object on the current drawing sheet
  • Symbol: Adds the contents of a SVG file as a symbol on the current drawing sheet
  • Draft View: Inserts a special Draft view of the selected object in the current drawing sheet
  • Spreadsheet View: Inserts a view of a selected spreadsheet in the current drawing sheet
  • Save sheet: Saves the current sheet as a SVG file
  • Project Shape: Creates a projection of the selected object (Source) in the 3D view.

Workflow

The document contains a 3D shape object (leg) from which we want to produce a drawing. Therefore a "Page" is created. A page it's instantiated from a template, for example, the "A3_Landscape" template. The template is an SVG document which can hold a page frame, a logo, and other elements.

In this page we can insert one or more views. Each view has a position on the page, a scale factor, and additional properties. Every time the page or the view or the referenced object changes, the page is regenerated and the page display updated.

Scripting

At the moment the graphical user interface workflow is very limited, so the scripting API is more interesting.

See the Drawing API example page for a description of the functions used to create drawing pages and views.

Templates

FreeCAD comes bundled with a set of default templates, but you can find more on the Drawing templates page.

Extending the Drawing Module

Some notes on the programming side of the drawing module will be added to the Drawing Documentation page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.

Tutorials

Macros

  • Macro Automatic drawing: Allows the user to get the view of his object in a drawing with 4 different position (front,top,iso,right). Needs some modification to be perfectly effective.
  • Macro CartoucheFC: This GUI macro to fill simply all fields of the cartridge of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.
  • Macro CartoucheFC 2: This GUI macro to fill simply all fields of the cartridge model 2 of the plan implementation worksheet FreeCAD.
  • Macro CartoucheFC Full: This GUI macro to fill simply all fields of the cartridge Misc templates Full of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.
  • Macro Corner shapes wizard/update: Pops up a dialog asking for the dimensions of your corner piece, then creates the object in the document and creates a page view with top, front and lateral views of the piece.

External links